## linux-grsec 4.5.7

=== Makefile ===
VERSION = 4
PATCHLEVEL = 5
SUBLEVEL = 7
EXTRAVERSION =
NAME = Blurry Fish Butt

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# o Do not use make's built-in rules and variables
#   (this increases performance and avoids hard-to-debug behaviour);
# o Look for make include files relative to root of kernel src
MAKEFLAGS += -rR --include-dir=$(CURDIR)

# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

# Avoid interference with shell env settings
unexport GREP_OPTIONS

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(filter 4.%,$(MAKE_VERSION)),)	# make-4
ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
  quiet=silent_
endif
else					# make-3.8x
ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
  quiet=silent_
endif
endif

export quiet Q KBUILD_VERBOSE

# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

# Cancel implicit rules on top Makefile
$(CURDIR)/Makefile Makefile: ;

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
								&& /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error failed to create output directory "$(saved-output)"))

PHONY += $(MAKECMDGOALS) sub-make

$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
	@:

sub-make: FORCE
	$(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
	-f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# Do not print "Entering directory ...",
# but we want to display it when entering to the output directory
# so that IDEs/editors are able to understand relative filenames.
MAKEFLAGS += --no-print-directory

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/sparse.txt" for more details, including
# where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif

ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

ifeq ($(KBUILD_SRC),)
        # building in the source tree
        srctree := .
else
        ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
                # building in a subdirectory of the source tree
                srctree := ..
        else
                srctree := $(KBUILD_SRC)
        endif
endif
objtree		:= .
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH

# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and
# SUBARCH is subsequently ignored.

SUBARCH := $(shell uname -m | sed -e s/i.86/x86/ -e s/x86_64/x86/ \
				  -e s/sun4u/sparc64/ \
				  -e s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/s390x/s390/ -e s/parisc64/parisc/ \
				  -e s/ppc.*/powerpc/ -e s/mips.*/mips/ \
				  -e s/sh[234].*/sh/ -e s/aarch64.*/arm64/ )

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# A third alternative is to store a setting in .config so that plain
# "make" in the configured kernel build directory always uses that.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile
ARCH		?= $(SUBARCH)
CROSS_COMPILE	?= $(CONFIG_CROSS_COMPILE:"%"=%)

# Architecture as present in compile.h
UTS_MACHINE 	:= $(ARCH)
SRCARCH 	:= $(ARCH)

# Additional ARCH settings for x86
ifeq ($(ARCH),i386)
        SRCARCH := x86
endif
ifeq ($(ARCH),x86_64)
        SRCARCH := x86
endif

# Additional ARCH settings for sparc
ifeq ($(ARCH),sparc32)
       SRCARCH := sparc
endif
ifeq ($(ARCH),sparc64)
       SRCARCH := sparc
endif

# Additional ARCH settings for sh
ifeq ($(ARCH),sh64)
       SRCARCH := sh
endif

# Additional ARCH settings for tile
ifeq ($(ARCH),tilepro)
       SRCARCH := tile
endif
ifeq ($(ARCH),tilegx)
       SRCARCH := tile
endif

# Where to locate arch specific headers
hdr-arch  := $(SRCARCH)

KCONFIG_CONFIG	?= .config
export KCONFIG_CONFIG

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC       = gcc
HOSTCXX      = g++
HOSTCFLAGS   = -Wall -Wmissing-prototypes -Wstrict-prototypes -O2 -fomit-frame-pointer -std=gnu89
HOSTCXXFLAGS = -O2

ifeq ($(shell $(HOSTCC) -v 2>&1 | grep -c "clang version"), 1)
HOSTCFLAGS  += -Wno-unused-value -Wno-unused-parameter \
		-Wno-missing-field-initializers -fno-delete-null-pointer-checks
endif

# Decide whether to build built-in, modular, or both.
# Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

# If we have only "make modules", don't compile built-in objects.
# When we're building modules with modversions, we need to consider
# the built-in objects during the descend as well, in order to
# make sure the checksums are up to date before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

# If we have "make <whatever> modules", compile modules
# in addition to whatever we do anyway.
# Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# We need some generic definitions (do not try to remake the file).
scripts/Kbuild.include: ;
include scripts/Kbuild.include

# Make variables (CC, etc...)
AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
INSTALLKERNEL  := installkernel
DEPMOD		= /sbin/depmod
PERL		= perl
PYTHON		= python
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
		  -Wbitwise -Wno-return-void $(CF)
CFLAGS_MODULE   =
AFLAGS_MODULE   =
LDFLAGS_MODULE  =
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=
CFLAGS_GCOV	= -fprofile-arcs -ftest-coverage -fno-tree-loop-im


# Use USERINCLUDE when you must reference the UAPI directories only.
USERINCLUDE    := \
		-I$(srctree)/arch/$(hdr-arch)/include/uapi \
		-Iarch/$(hdr-arch)/include/generated/uapi \
		-I$(srctree)/include/uapi \
		-Iinclude/generated/uapi \
                -include $(srctree)/include/linux/kconfig.h

# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
LINUXINCLUDE    := \
		-I$(srctree)/arch/$(hdr-arch)/include \
		-Iarch/$(hdr-arch)/include/generated/uapi \
		-Iarch/$(hdr-arch)/include/generated \
		$(if $(KBUILD_SRC), -I$(srctree)/include) \
		-Iinclude \
		$(USERINCLUDE)

KBUILD_CPPFLAGS := -D__KERNEL__

KBUILD_CFLAGS   := -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \
		   -fno-strict-aliasing -fno-common \
		   -Werror-implicit-function-declaration \
		   -Wno-format-security \

=== debian/changelog ===
linux-grsec (4.5.7-1+grsec201606222150+1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Yves-Alexis Perez <corsac@debian.org>  Thu, 30 Jun 2016 15:29:02 +0200

linux-grsec (4.5.7-1+grsec201606222150+1) unstable; urgency=medium

  * Update grsecurity patch to 3.1-4.5.7-201606222150.

 -- Yves-Alexis Perez <corsac@debian.org>  Thu, 23 Jun 2016 21:05:18 +0200

linux-grsec (4.5.7-1+grsec201606142010+1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Yves-Alexis Perez <corsac@debian.org>  Fri, 24 Jun 2016 14:30:08 +0200

linux-grsec (4.5.7-1+grsec201606142010+1) unstable; urgency=medium

  * Update grsecurity patch to 3.1-4.5.7-201606142010.

 -- Yves-Alexis Perez <corsac@debian.org>  Fri, 17 Jun 2016 21:20:13 +0200

linux-grsec (4.5.7-1+grsec201606110914+1) unstable; urgency=medium

  * New upstream stable update:
    https://www.kernel.org/pub/linux/kernel/v4.x/ChangeLog-4.5.6
    - perf/x86/intel/pt: Generate PMI in the STOP region as well
    - perf/core: Fix perf_event_open() vs. execve() race
    - arm64: Fix typo in the pmdp_huge_get_and_clear() definition
    - arm64: Ensure pmd_present() returns false after pmd_mknotpresent()
    - arm64: Implement ptep_set_access_flags() for hardware AF/DBM
    - arm64: Implement pmdp_set_access_flags() for hardware AF/DBM
    - arm64: cpuinfo: Missing NULL terminator in compat_hwcap_str
    - arm/arm64: KVM: Enforce Break-Before-Make on Stage-2 page tables
    - kvm: arm64: Fix EC field in inject_abt64
    - remove directory incorrectly tries to set delete on close on non-empty directories
    - fs/cifs: correctly to anonymous authentication via NTLMSSP
    - fs/cifs: correctly to anonymous authentication for the LANMAN authentication
    - fs/cifs: correctly to anonymous authentication for the NTLM(v1) authentication
    - fs/cifs: correctly to anonymous authentication for the NTLM(v2) authentication
    - asix: Fix offset calculation in asix_rx_fixup() causing slow transmissions
    - ring-buffer: Use long for nr_pages to avoid overflow failures
    - ring-buffer: Prevent overflow of size in ring_buffer_resize()
    - crypto: caam - fix caam_jr_alloc() ret code
    - crypto: talitos - fix ahash algorithms registration
    - crypto: sun4i-ss - Replace spinlock_bh by spin_lock_irq{save|restore}
    - clk: qcom: msm8916: Fix crypto clock flags
    - sched/loadavg: Fix loadavg artifacts on fully idle and on fully loaded systems
    - mfd: omap-usb-tll: Fix scheduling while atomic BUG
    - Input: pwm-beeper - fix - scheduling while atomic
    - irqchip/gic: Ensure ordering between read of INTACK and shared data
    - irqchip/gic-v3: Configure all interrupts as non-secure Group-1
    - nfc: st21nfca: Fix static checker warning
    - can: fix handling of unmodifiable configuration options
    - mmc: mmc: Fix partition switch timeout for some eMMCs
    - ACPI / PM: Export acpi_device_fix_up_power()
    - mmc: sdhci-acpi: Ensure connected devices are powered when probing
    - mmc: sdhci-acpi: Remove MMC_CAP_BUS_WIDTH_TEST for Intel controllers
    - ACPI / osi: Fix an issue that acpi_osi=!* cannot disable ACPICA internal strings
    - dell-rbtn: Ignore ACPI notifications if device is suspended
    - mmc: longer timeout for long read time quirk
    - mmc: sdhci-pci: Remove MMC_CAP_BUS_WIDTH_TEST for Intel controllers
    - Bluetooth: vhci: fix open_timeout vs. hdev race
    - Bluetooth: vhci: purge unhandled skbs
    - Bluetooth: vhci: Fix race at creating hci device
    - mei: fix NULL dereferencing during FW initiated disconnection
    - mei: amthif: discard not read messages
    - mei: bus: call mei_cl_read_start under device lock
    - USB: serial: mxuport: fix use-after-free in probe error path
    - USB: serial: keyspan: fix use-after-free in probe error path
    - USB: serial: quatech2: fix use-after-free in probe error path
    - USB: serial: io_edgeport: fix memory leaks in attach error path
    - USB: serial: io_edgeport: fix memory leaks in probe error path
    - USB: serial: option: add support for Cinterion PH8 and AHxx
    - USB: serial: option: add more ZTE device ids
    - USB: serial: option: add even more ZTE device ids
    - usb: gadget: f_fs: Fix EFAULT generation for async read operations
    - usb: f_mass_storage: test whether thread is running before starting another
    - usb: misc: usbtest: fix pattern tests for scatterlists.
    - USB: leave LPM alone if possible when binding/unbinding interface drivers
    - usb: gadget: udc: core: Fix argument of dev_err() in usb_gadget_map_request()
    - staging: comedi: das1800: fix possible NULL dereference
    - KVM: MTRR: remove MSR 0x2f8
    - KVM: x86: fix ordering of cr0 initialization code in vmx_cpu_reset
    - MIPS: KVM: Fix timer IRQ race when freezing timer
    - MIPS: KVM: Fix timer IRQ race when writing CP0_Compare
    - KVM: x86: mask CPUID(0xD,0x1).EAX against host value
    - xen/x86: actually allocate legacy interrupts on PV guests
    - tty: vt, return error when con_startup fails
    - TTY: n_gsm, fix false positive WARN_ON
    - tty/serial: atmel: fix hardware handshake selection
    - Fix OpenSSH pty regression on close
    - serial: 8250_pci: fix divide error bug if baud rate is 0
    - serial: 8250_mid: use proper bar for DNV platform
    - serial: 8250_mid: recognize interrupt source in handler
    - serial: samsung: Reorder the sequence of clock control when call s3c24xx_serial_set_termios()
    - locking,qspinlock: Fix spin_is_locked() and spin_unlock_wait()
    - clk: bcm2835: add locking to pll*_on/off methods
    - watchdog: sp5100_tco: properly check for new register layouts
    - mcb: Fixed bar number assignment for the gdd
    - ALSA: hda/realtek - New codecs support for ALC234/ALC274/ALC294
    - ALSA: hda - Fix headphone noise on Dell XPS 13 9360
    - ALSA: hda/realtek - Add support for ALC295/ALC3254
    - ALSA: hda - Fix headset mic detection problem for one Dell machine


## linux-grsec 4.6.3

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 VERSION = 4
-PATCHLEVEL = 5
-SUBLEVEL = 7
+PATCHLEVEL = 6
+SUBLEVEL = 3
 EXTRAVERSION =
-NAME = Blurry Fish Butt
+NAME = Charred Weasel
 
 # *DOCUMENTATION*
 # To see a list of typical targets execute "make help"
@@ -365,6 +365,7 @@
 CFLAGS_KERNEL	=
 AFLAGS_KERNEL	=
 CFLAGS_GCOV	= -fprofile-arcs -ftest-coverage -fno-tree-loop-im
+CFLAGS_KCOV	= -fsanitize-coverage=trace-pc
 
 
 # Use USERINCLUDE when you must reference the UAPI directories only.
@@ -389,5 +390,3 @@
 
 KBUILD_CFLAGS   := -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \
 		   -fno-strict-aliasing -fno-common \
-		   -Werror-implicit-function-declaration \
-		   -Wno-format-security \

=== debian/changelog ===
linux-grsec (4.6.3-1+grsec201607062159+1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Yves-Alexis Perez <corsac@debian.org>  Sat, 16 Jul 2016 15:42:30 +0200

linux-grsec (4.6.3-1+grsec201607062159+1) unstable; urgency=medium

  * Update grsecurity patch to 3.1-4.6.3-201607062159.

 -- Yves-Alexis Perez <corsac@debian.org>  Thu, 07 Jul 2016 10:04:14 +0200

linux-grsec (4.6.3-1+grsec201607051723+1) unstable; urgency=medium

  * Pull src:linux changes up to 4.6.3-1.
  * Update grsecurity patch to 3.1-4.6.3-201607051723.
  * Disable patches with grsecurity conflicts:
    - debian/mips-disable-werror (MIPS unsupported)
    - debian/mips-libgcc-fix-abi-change-in-4.6.2 (no ABI stability and MIPs
      unsupported)
  * Disable patches already included in grsecurity:
    - bugfix/all/keys-potential-uninitialized-variable
    - bugfix/all/percpu-fix-synchronization-between-chunk-map_extend
    - bugfix/all/percpu-fix-synchronization-between-synchronous-map-e
    - bugfix/all/posix_acl-add-set_posix_acl
    - bugfix/all/nfsd-check-permissions-when-setting-acls
    - bugfix/all/HID-hiddev-validate-num_values-for-HIDIOCGUSAGES-HID

 -- Yves-Alexis Perez <corsac@debian.org>  Wed, 06 Jul 2016 17:37:41 +0200

linux (4.6.3-1) unstable; urgency=medium

  [ Ben Hutchings ]
  * New upstream stable update:
    https://www.kernel.org/pub/linux/kernel/v4.x/ChangeLog-4.6.3
    - scsi_lib: correctly retry failed zero length REQ_TYPE_FS commands
    - scsi: Add QEMU CD-ROM to VPD Inquiry Blacklist
    - netlink: Fix dump skb leak/double free
    - tipc: fix nametable publication field in nl compat
    - switchdev: pass pointer to fib_info instead of copy
    - tuntap: correctly wake up process during uninit
    - bpf: Use mount_nodev not mount_ns to mount the bpf filesystem
    - udp: prevent skbs lingering in tunnel socket queues
    - uapi glibc compat: fix compilation when !__USE_MISC in glibc
    - bpf, inode: disallow userns mounts
    - [armhf] net: mvneta: Fix lacking spinlock initialization
    - net: hwbm: Fix unbalanced spinlock in error case
    - sfc: on MC reset, clear PIO buffer linkage in TXQs
    - team: don't call netdev_change_features under team->lock
    - net: alx: use custom skb allocator
    - net: stmmac: Fix incorrect memcpy source memory
    - vxlan: Accept user specified MTU value when create new vxlan link
    - net: nps_enet: Disable interrupts before napi reschedule
    - bpf, trace: use READ_ONCE for retrieving file ptr
    - tcp: record TLP and ER timer stats in v6 stats
    - bridge: Don't insert unnecessary local fdb entry on changing mac address
    - l2tp: fix configuration passed to setup_udp_tunnel_sock()
    - ipv6: Skip XFRM lookup if dst_entry in socket cache is valid
    - [armhf,arm64] KVM: vgic-v2: Clear all dirty LRs
    - [armhf,arm64] KVM: vgic-v3: Clear all dirty LRs
    - [x86] KVM: fix OOPS after invalid KVM_SET_DEBUGREGS
    - KVM: irqfd: fix NULL pointer dereference in kvm_irq_map_gsi
    - [arm*] drivers/perf: arm_pmu: Defer the setting of __oprofile_cpu_pmu
    - [x86] ALSA: hda - Add PCI ID for Kabylake
    - [x86] ALSA: hda - Fix headset mic detection problem for Dell machine
    - ALSA: hda/realtek - ALC256 speaker noise issue
    - ALSA: hda/realtek - Add support for new codecs ALC700/ALC701/ALC703
    - [x86] ALSA: hda/realtek: Add T560 docking unit fixup
    - [armhf] fix PTRACE_SETVFPREGS on SMP systems
    - gpio: bail out silently on NULL descriptors
    - gpiolib: Fix NULL pointer deference
    - gpiolib: Fix unaligned used of reference counters
    - [s390x] bpf: fix recache skb->data/hlen for skb_vlan_push/pop
    - [s390x] bpf: reduce maximum program size to 64 KB
    - [armhf,arm64] irqchip/gic-v3: Fix ICC_SGI1R_EL1.INTID decoding mask
    - [x86] crypto: ccp - Fix AES XTS error for request sizes above 4096
    - [arm64] Provide "model name" in /proc/cpuinfo for PER_LINUX32 tasks
    - [arm64] mm: always take dirty state from new pte in ptep_set_access_flags
    - [powerpc*] pseries/eeh: Handle RTAS delay requests in configure_bridge
    - [powerpc*] Fix definition of SIAR and SDAR registers
    - [powerpc*] Use privileged SPR number for MMCR2
    - [powerpc*] pseries: Add POWER8NVL support to
      ibm,client-architecture-support call
    - [powerpc*] mm/hash: Fix the reference bit update when handling hash fault
    - [hppa] Fix pagefault crash in unaligned __get_user() call
    - memcg: add RCU locking around css_for_each_descendant_pre() in
      memcg_offline_kmem()
    - wext: Fix 32 bit iwpriv compatibility issue with 64 bit Kernel
    - mm: thp: broken page count after commit aa88b68c3b1d
    - [x86] entry/traps: Don't force in_interrupt() to return true in IST
      handlers
    - fix d_walk()/non-delayed __d_free() race
    - [sparc64] Reduce TLB flushes during hugepte changes
    - [sparc64] Take ctx_alloc_lock properly in hugetlb_setup().
    - [sparc64] Harden signal return frame checks.
    - [sparc64] Fix return from trap window fill crashes.
    - drm/core: Do not preserve framebuffer on rmfb, v4.
    - [x86] Revert "drm/i915: Exit cherryview_irq_handler() after one pass"
    - gpio: make sure gpiod_to_irq() returns negative on NULL desc
  * [powerpc*] tm: Always reclaim in start_thread() for exec() class syscalls
    (CVE-2016-5828)

  [ Salvatore Bonaccorso ]
  * HID: hiddev: validate num_values for HIDIOCGUSAGES, HIDIOCSUSAGES commands
    (CVE-2016-5829)

 -- Ben Hutchings <ben@decadent.org.uk>  Mon, 04 Jul 2016 20:10:24 +0200

linux (4.6.2-2) unstable; urgency=medium

  * [mips*] Fix ABI changes in 4.6.2
  * [rt] Update to 4.6.2-rt5:
    - mm/memcontrol: mem_cgroup_migrate() - replace another local_irq_disable()
      w. local_lock_irq()
  * KEYS: potential uninitialized variable (CVE-2016-4470)
  * percpu: fix synchronization between chunk->map_extend_work and chunk
    destruction (CVE-2016-4794)
  * percpu: fix synchronization between synchronous map extension and


=== debian/control ===
Source: linux-grsec
Section: kernel
Priority: optional
Maintainer: Yves-Alexis Perez <corsac@debian.org>
Standards-Version: 3.9.5
Build-Depends: debhelper, python3:any, quilt, cpio <!stage1>, xz-utils <!stage1>, kernel-wedge (>= 2.93~) <!stage1>, kmod <!stage1>, bc <!stage1>, libssl-dev <!stage1>, openssl <!stage1>, asciidoc <!stage1 !nodoc !pkg.linux.notools>, xmlto <!stage1 !nodoc !pkg.linux.notools>, bison <!stage1 !pkg.linux.notools>, flex <!stage1 !pkg.linux.notools>, gcc-multilib [amd64 ppc64 s390x sparc64] <!stage1 !pkg.linux.notools>, libaudit-dev <!stage1 !pkg.linux.notools>, libdw-dev <!stage1 !pkg.linux.notools>, libelf-dev <!stage1 !pkg.linux.notools>, libiberty-dev <!stage1 !pkg.linux.notools>, libnewt-dev <!stage1 !pkg.linux.notools>, libnuma-dev [amd64 arm64 hppa i386 mips mips64 mips64el mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el powerpc powerpcspe ppc64 ppc64el sparc x32] <!stage1 !pkg.linux.notools>, libperl-dev <!stage1 !pkg.linux.notools>, libunwind8-dev [amd64 armel armhf arm64 i386] <!stage1 !pkg.linux.notools>, python-dev <!stage1 !pkg.linux.notools>, autoconf <!stage1 !pkg.linux.notools>, automake <!stage1 !pkg.linux.notools>, libtool <!stage1 !pkg.linux.notools>, libglib2.0-dev <!stage1 !pkg.linux.notools>, libudev-dev <!stage1 !pkg.linux.notools>, libwrap0-dev <!stage1 !pkg.linux.notools>, libpci-dev <!stage1 !pkg.linux.notools>, dh-python <!stage1>, dh-systemd <!stage1 !pkg.linux.notools>, gcc-4.9 [amd64 i386], gcc-4.9-plugin-dev [amd64 i386] <!stage1>
Build-Depends-Indep: patchutils <!stage1>, xmlto <!stage1 !nodoc>
Homepage: https://www.kernel.org/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/linux-grsec.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/linux-grsec.git

Package: linux-grsec-source-4.6
Architecture: all
Section: kernel
Depends: binutils, xz-utils, ${misc:Depends}
Recommends: libc6-dev | libc-dev, gcc, make, bc
Suggests: libncurses-dev | ncurses-dev, libqt4-dev, pkg-config
Description: Linux kernel source for version 4.6 with Debian patches
 This package provides source code for the Linux kernel version 4.6. This
 source closely tracks official Linux kernel releases.  Debian's
 modifications to that source consist of security fixes, bug fixes, and
 features that have already been (or are believed to be) accepted by the
 upstream maintainers.
Build-Profiles: <!stage1>
Multi-Arch: foreign

Package: linux-grsec-support-4.6.0-1
Architecture: all
Section: devel
Depends: ${python3:Depends}, ${misc:Depends}
Description: Support files for Linux 4.6
 This package provides support files for the Linux kernel build, e.g.
 scripts to handle ABI information and for generation of build system meta
 data.
Build-Profiles: <!stage1>
Multi-Arch: foreign

Package: linux-headers-4.6.0-1-common-grsec
Architecture: amd64 i386
Depends: ${misc:Depends}
Description: Common header files for Linux 4.6.0-1-grsec
 This package provides the architecture-specific common kernel header files
 for Linux kernel version 4.6.0-1-grsec, generally used for building
 out-of-tree kernel modules.  To obtain a complete set of headers you also
 need to install the linux-headers-4.6.0-1-(flavour) package, matching the
 flavour of the kernel you intend the build for.
Build-Profiles: <!stage1>

Package: linux-image-4.6.0-1-grsec-amd64
Architecture: amd64
Depends: kmod, linux-base (>= 4.3~), ${misc:Depends}, linux-grsec-base [amd64], initramfs-tools (>= 0.110~) [amd64] | linux-initramfs-tool [amd64]
Recommends: firmware-linux-free, ${kernel:Recommends}, gradm2 [amd64], paxctl [amd64], attr [amd64]
Suggests: linux-doc-4.6, debian-kernel-handbook, grub-pc [amd64] | grub-efi [amd64] | extlinux [amd64]
Breaks: xserver-xorg-input-vmmouse (<< 1:13.0.99) [amd64], initramfs-tools (<< 0.110~)
Description: Linux 4.6 for 64-bit PCs, Grsecurity protection
 The Linux kernel 4.6 and modules for use on PCs with AMD64, Intel 64 or
 VIA Nano processors.
 .
 This kernel includes support for Grsecurity and PaX security hardening
 features
Build-Profiles: <!stage1>

Package: linux-headers-4.6.0-1-grsec-amd64
Architecture: amd64
Depends: linux-headers-4.6.0-1-common-grsec (= ${binary:Version}), linux-kbuild-4.6, ${misc:Depends}, gcc-4.9, gcc-4.9-plugin-dev
Description: Header files for Linux 4.6.0-1-grsec-amd64
 This package provides the architecture-specific kernel header files for
 Linux kernel 4.6.0-1-grsec-amd64, generally used for building out-of-tree
 kernel modules.  These files are going to be installed into
 /usr/src/linux-headers-4.6.0-1-grsec-amd64, and can be used for building
 modules that load into the kernel provided by the
 linux-image-4.6.0-1-grsec-amd64 package.
Build-Profiles: <!stage1>

Package: linux-image-4.6.0-1-grsec-686-pae
Architecture: i386
Depends: kmod, linux-base (>= 4.3~), ${misc:Depends}, linux-grsec-base [i386], initramfs-tools (>= 0.110~) [i386] | linux-initramfs-tool [i386]
Recommends: firmware-linux-free, ${kernel:Recommends}, gradm2 [i386], paxctl [i386], attr [i386]
Suggests: linux-doc-4.6, debian-kernel-handbook, grub-pc [i386] | extlinux [i386]
Breaks: xserver-xorg-input-vmmouse (<< 1:13.0.99) [i386], initramfs-tools (<< 0.110~)
Description: Linux 4.6 for modern PCs, Grsecurity protection
 The Linux kernel 4.6 and modules for use on PCs with one or more
 processors supporting PAE.
 .
 This kernel includes support for Grsecurity and PaX security hardening
 features
 .
 This kernel requires PAE (Physical Address Extension). This feature is
 supported by the Intel Pentium Pro/II/III/4/4M/D, Xeon, Core and Atom; AMD
 Geode NX, Athlon (K7), Duron, Opteron, Sempron, Turion or Phenom;
 Transmeta Efficeon; VIA C7; and some other processors.
Build-Profiles: <!stage1>

Package: linux-headers-4.6.0-1-grsec-686-pae
Architecture: i386
Depends: linux-headers-4.6.0-1-common-grsec (= ${binary:Version}), linux-kbuild-4.6, ${misc:Depends}, gcc-4.9, gcc-4.9-plugin-dev
Description: Header files for Linux 4.6.0-1-grsec-686-pae
 This package provides the architecture-specific kernel header files for
 Linux kernel 4.6.0-1-grsec-686-pae, generally used for building
 out-of-tree kernel modules.  These files are going to be installed into
 /usr/src/linux-headers-4.6.0-1-grsec-686-pae, and can be used for building
 modules that load into the kernel provided by the
 linux-image-4.6.0-1-grsec-686-pae package.
Build-Profiles: <!stage1>

=== debian/tests/control ===
Tests: selftests
Restrictions: breaks-testbed, needs-root, isolation-machine
Depends: kexec-tools, python3, gcc, make, libpopt-dev, gcc-multilib [amd64], bc, fuse, libfuse-dev, pkg-config, linux-image-4.6.0-1-grsec-amd64 [amd64], linux-image-4.6.0-1-grsec-686-pae [i386]
Classes: smp

## linux-grsec 4.7.5

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 VERSION = 4
-PATCHLEVEL = 6
-SUBLEVEL = 3
+PATCHLEVEL = 7
+SUBLEVEL = 5
 EXTRAVERSION =
-NAME = Charred Weasel
+NAME = Psychotic Stoned Sheep
 
 # *DOCUMENTATION*
 # To see a list of typical targets execute "make help"
@@ -127,6 +127,10 @@
 
 # Cancel implicit rules on top Makefile
 $(CURDIR)/Makefile Makefile: ;
+
+ifneq ($(words $(subst :, ,$(CURDIR))), 1)
+  $(error main directory cannot contain spaces nor colons)
+endif
 
 ifneq ($(KBUILD_OUTPUT),)
 # Invoke a second make in the output directory, passing relevant variables
@@ -142,7 +146,7 @@
 $(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
 	@:
 
-sub-make: FORCE
+sub-make:
 	$(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
 	-f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
 
@@ -359,12 +363,14 @@
 
 CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
 		  -Wbitwise -Wno-return-void $(CF)
+NOSTDINC_FLAGS  =
 CFLAGS_MODULE   =
 AFLAGS_MODULE   =
 LDFLAGS_MODULE  =
 CFLAGS_KERNEL	=
 AFLAGS_KERNEL	=
-CFLAGS_GCOV	= -fprofile-arcs -ftest-coverage -fno-tree-loop-im
+LDFLAGS_vmlinux =
+CFLAGS_GCOV	= -fprofile-arcs -ftest-coverage -fno-tree-loop-im -Wno-maybe-uninitialized
 CFLAGS_KCOV	= -fsanitize-coverage=trace-pc
 
 
@@ -386,7 +392,3 @@
 		-Iinclude \
 		$(USERINCLUDE)
 
-KBUILD_CPPFLAGS := -D__KERNEL__
-
-KBUILD_CFLAGS   := -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \
-		   -fno-strict-aliasing -fno-common \

=== debian/changelog ===
linux-grsec (4.7.5-1+grsec201609261522+1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Yves-Alexis Perez <corsac@debian.org>  Tue, 04 Oct 2016 22:26:27 +0200

linux-grsec (4.7.5-1+grsec201609261522+1) unstable; urgency=medium

  * Pull changes from src:linux up to 4.7.5-1.
  * Grsecurity patch updated to 3.1-4.7.5-201609261522.

 -- Yves-Alexis Perez <corsac@debian.org>  Tue, 27 Sep 2016 21:40:06 +0200

linux (4.7.5-1) unstable; urgency=medium

  * New upstream stable update:
    https://www.kernel.org/pub/linux/kernel/v4.x/ChangeLog-4.7.5
    - [armhf] clocksource/drivers/sun4i: Clear interrupts after stopping timer
      in probe function
    - fscrypto: require write access to mount to set encryption policy
    - [arm64] drm/msm: protect against faults from copy_from_user() in submit
      ioctl
    - bpf: fix method of PTR_TO_PACKET reg id generation
    - ipv4: panic in leaf_walk_rcu due to stale node pointer
    - vti: flush x-netns xfrm cache when vti interface is removed
    - bpf: fix write helpers with regards to non-linear parts
    - net/irda: handle iriap_register_lsap() allocation failure
    - net/sctp: always initialise sctp_ht_iter::start_fail
    - net: ipv6: Do not keep IPv6 addresses when IPv6 is disabled
    - tipc: fix NULL pointer dereference in shutdown()
    - net/mlx5: Fix pci error recovery flow
    - net/mlx5: Added missing check of msg length in verifying its signature
    - net/mlx5e: Use correct flow dissector key on flower offloading
    - net sched: fix encoding to use real length
    - udp: fix poll() issue with zero sized packets
    - tcp: properly scale window in tcp_v[46]_reqsk_send_ack()
    - sctp: fix overrun in sctp_diag_dump_one()
    - tun: fix transmit timestamp support
    - [armhf] net: dsa: bcm_sf2: Fix race condition while unmasking interrupts
    - Revert "phy: IRQ cannot be shared"
    - net: smc91x: fix SMC accesses
    - bridge: re-introduce 'fix parsing of MLDv2 reports'
    - bonding: Fix bonding crash
    - Revert "af_unix: Fix splice-bind deadlock"
    - af_unix: split 'u->readlock' into two: 'iolock' and 'bindlock'
    - ipv6: release dst in ping_v6_sendmsg
    - [arm64] bnxt_en: Fix TX push operation on ARM64.
    - ipv6: addrconf: fix dev refcont leak when DAD failed
    - tcp: fastopen: avoid negative sk_forward_alloc
    - net/mlx5e: Fix parsing of vlan packets when updating lro header
    - tcp: cwnd does not increase in TCP YeAH
    - [powerpc*] tm: do not use r13 for tabort_syscall
    - [powerpc*] powernv : Drop reference added by kset_find_obj()
    - [powerpc*] sysdev: cpm: fix gpio save_regs functions
    - [powerpc*] mm: Don't alias user region to other regions below PAGE_OFFSET
    - [powerpc*] powernv: Fix corrupted PE allocation bitmap on releasing PE
    - kernfs: don't depend on d_find_any_alias() when generating notifications
    - pNFS/flexfiles: Fix an Oopsable condition when connection to the DS fails
    - pNFS: The client must not do I/O to the DS if it's lease has expired
    - NFSv4.1: Fix Oopsable condition in server callback races
    - NFSv4.x: Fix a refcount leak in nfs_callback_up_net
    - nfsd: Close race between nfsd4_release_lockowner and nfsd4_lock
    - pNFS: Ensure LAYOUTGET and LAYOUTRETURN are properly serialised
    - NFSv4.1: Fix the CREATE_SESSION slot number accounting
    - kexec: fix double-free when failing to relocate the purgatory
    - mm, mempolicy: task->mempolicy must be NULL before dropping final
      reference
    - ahci: disable correct irq for dummy ports
    - audit: fix exe_file access in audit_exe_compare
    - dm flakey: fix reads to be issued if drop_writes configured
    - IB/hfi1,IB/qib: Fix qp_stats sleep with rcu read lock held
    - IB/uverbs: Fix race between uverbs_close and remove_one
    - IB/hfi1: Reset QSFP on every run through channel tuning
    - [amd64] mm: fix cache mode of dax pmd mappings
    - [x86] paravirt: Do not trace _paravirt_ident_*() functions
    - [x86] AMD: Apply erratum 665 on machines without a BIOS fix
    - [s390x] KVM: don't use current->thread.fpu.* when accessing registers
    - [armhf,arm64] kvm-arm: Unmap shadow pagetables properly
    - [x86] kvm: correctly reset dest_map->vector when restoring LAPIC state
    - iio: sw-trigger: Fix config group initialization
    - [armhf] iio: adc: rockchip_saradc: reset saradc controller before
      programming it
    - [armhf] iio: adc: ti_am335x_adc: Protect FIFO1 from concurrent access
    - [armhf] iio: adc: ti_am335x_adc: Increase timeout value waiting for ADC
      sample
    - iio:ti-ads1015: fix a wrong pointer definition.
    - [x86] iio: accel: bmc150: reset chip at init time
    - iio: fix pressure data output unit in hid-sensor-attributes
    - iio:core: fix IIO_VAL_FRACTIONAL sign handling
    - iio: ensure ret is initialized to zero before entering do loop
    - serial: 8250_mid: fix divide error bug if baud rate is 0
    - serial: 8250: added acces i/o products quad and octal serial cards
    - [armhf,arm64] usb: chipidea: udc: fix NULL ptr dereference in
      isr_setup_status_phase
    - USB: change bInterval default to 10 ms
    - devpts: return NULL pts 'priv' entry for non-devpts nodes
    - cpuset: make sure new tasks conform to the current config of the cpuset
    - [armhf] dts: rockchip: add reset node for the exist saradc SoCs
    - [armhf] imx6: add missing BM_CLPCR_BYP_MMDC_CH0_LPM_HS setting for imx6ul
    - [armhf] imx6: add missing BM_CLPCR_BYPASS_PMIC_READY setting for imx6sx
    - [armel] kirkwood: ib62x0: fix size of u-boot environment partition
    - [armhf] OMAP3: hwmod data: Add sysc information for DSI
    - [armel] dts: kirkwood: Fix PCIe label on OpenRD
    - [armhf] dts: imx6qdl: Fix SPDIF regression
    - [armhf] dts: armada-388-clearfog: number LAN ports properly
    - dm log writes: fix check of kthread_run() return value
    - dm crypt: fix free of bad values after tfm allocation failure
